Index: /pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 4460)
+++ /pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 4461)
@@ -33,4 +33,7 @@
 //
 SOURCE	base64.c
+SOURCE	cli.c
+SOURCE	cli_console.c
+SOURCE	cli_telnet.c
 SOURCE	crc32.c
 SOURCE	dns.c
Index: /pjproject/trunk/pjlib-util/include/pjlib-util.h
===================================================================
--- /pjproject/trunk/pjlib-util/include/pjlib-util.h	(revision 4460)
+++ /pjproject/trunk/pjlib-util/include/pjlib-util.h	(revision 4461)
@@ -64,3 +64,6 @@
 #include <pjlib-util/http_client.h>
 
+/** CLI Telnet **/
+#include <pjlib-util/cli_telnet.h>
+
 #endif	/* __PJLIB_UTIL_H__ */
Index: /pjproject/trunk/pjlib-util/include/pjlib-util/cli_telnet.h
===================================================================
--- /pjproject/trunk/pjlib-util/include/pjlib-util/cli_telnet.h	(revision 4460)
+++ /pjproject/trunk/pjlib-util/include/pjlib-util/cli_telnet.h	(revision 4461)
@@ -35,4 +35,29 @@
  */
 
+ /**
+ * This structure contains the information about the telnet.
+ * Application will get updated information each time the telnet is started/
+ * restarted.
+ */
+typedef struct pj_cli_telnet_info
+{
+    /**
+     * The telnet's ip address.
+     */
+    pj_str_t	ip_address;
+
+    /**
+     * The telnet's port number.
+     */
+    pj_uint16_t port;
+} pj_cli_telnet_info;
+
+/**
+ * This specifies the callback called when telnet is started
+ *
+ * @param telnet_info   The telnet runtime information.
+ *
+ */
+typedef void (*pj_cli_telnet_on_started)(pj_cli_telnet_info *telnet_info);
 
 /**
@@ -86,6 +111,12 @@
     pj_str_t prompt_str;
 
+    /**
+     * Specify the pj_cli_telnet_on_started callback.
+     *
+     * Default: empty
+     */
+    pj_cli_telnet_on_started on_started;
+
 } pj_cli_telnet_cfg;
-
 
 /**
Index: /pjproject/trunk/pjlib-util/include/pjlib-util/config.h
===================================================================
--- /pjproject/trunk/pjlib-util/include/pjlib-util/config.h	(revision 4460)
+++ /pjproject/trunk/pjlib-util/include/pjlib-util/config.h	(revision 4461)
@@ -292,5 +292,5 @@
  */
 #ifndef PJ_CLI_MAX_CMDBUF
-#   define PJ_CLI_MAX_CMDBUF		120
+#   define PJ_CLI_MAX_CMDBUF		512
 #endif
 
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4460)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/cli_telnet.c	(revision 4461)
@@ -30,4 +30,13 @@
 #include <pjlib-util/errno.h>
 #include <pjlib-util/scanner.h>
+#include <pj/addr_resolv.h>
+#include <pj/compat/socket.h>
+
+#if (defined(PJ_WIN32) && PJ_WIN32!=0) || \
+    (defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0)
+
+#define EADDRINUSE WSAEADDRINUSE 
+
+#endif
 
 #define CLI_TELNET_BUF_SIZE 256
@@ -45,4 +54,12 @@
 
 #define MAX_CLI_TELNET_OPTIONS 256
+/** Maximum retry on Telnet Restart **/
+#define MAX_RETRY_ON_TELNET_RESTART 100
+/** Minimum number of millisecond to wait before retrying to re-bind on
+ * telnet restart **/
+#define MIN_WAIT_ON_TELNET_RESTART 20
+/** Maximum number of millisecod to wait before retrying to re-bind on
+ *  telnet restart **/
+#define MAX_WAIT_ON_TELNET_RESTART 1000
 
 /**
@@ -262,5 +279,5 @@
 } cli_telnet_sess;
 
-struct cli_telnet_fe
+typedef struct cli_telnet_fe
 {
     pj_cli_front_end        base;
@@ -273,6 +290,6 @@
     pj_thread_t            *worker_thread;
     pj_bool_t               is_quitting;
-    pj_mutex_t             *mutex;
-};
+    pj_mutex_t             *mutex;    
+} cli_telnet_fe;
 
 /* Forward Declaration */
@@ -282,4 +299,7 @@
 static pj_status_t telnet_sess_send(cli_telnet_sess *sess,
                                     const pj_str_t *str);
+
+static pj_status_t telnet_start(cli_telnet_fe *fe);
+static pj_status_t telnet_restart(cli_telnet_fe *tfe);
 
 /**
@@ -646,5 +666,5 @@
     pj_str_t send_data;
     char data_str[128];
-    struct cli_telnet_fe *fe = (struct cli_telnet_fe *)sess->base.fe;
+    cli_telnet_fe *fe = (cli_telnet_fe *)sess->base.fe;
 
     send_data.ptr = &data_str[0];
@@ -670,5 +690,5 @@
     unsigned len;
     unsigned i;
-    struct cli_telnet_fe *fe = (struct cli_telnet_fe *)sess->base.fe;
+    cli_telnet_fe *fe = (cli_telnet_fe *)sess->base.fe;
 
     send_data.ptr = &data_str[0];
@@ -744,5 +764,5 @@
     pj_str_t send_data;
     char data[1028];
-    struct cli_telnet_fe *fe = (struct cli_telnet_fe *)sess->base.fe;
+    cli_telnet_fe *fe = (cli_telnet_fe *)sess->base.fe;
     const pj_cli_hint_info *hint = info->hint;
     out_parse_state parse_state = OP_NORMAL;
@@ -1319,5 +1339,5 @@
 {
     cli_telnet_sess *tsess = (cli_telnet_sess *)sess;
-    pj_mutex_t *mutex = ((struct cli_telnet_fe *)sess->fe)->mutex;
+    pj_mutex_t *mutex = ((cli_telnet_fe *)sess->fe)->mutex;
 
     pj_mutex_lock(mutex);
@@ -1335,5 +1355,5 @@
 		                const char *data, int len)
 {
-    struct cli_telnet_fe * tfe = (struct cli_telnet_fe *)fe;
+    cli_telnet_fe *tfe = (cli_telnet_fe *)fe;
     pj_cli_sess *sess;    
 
@@ -1358,5 +1378,5 @@
 static void telnet_fe_destroy(pj_cli_front_end *fe)
 {
-    struct cli_telnet_fe *tfe = (struct cli_telnet_fe *)fe;
+    cli_telnet_fe *tfe = (cli_telnet_fe *)fe;
     pj_cli_sess *sess;
 
@@ -1392,5 +1412,5 @@
 static int poll_worker_thread(void *p)
 {
-    struct cli_telnet_fe *fe = (struct cli_telnet_fe *)p;
+    cli_telnet_fe *fe = (cli_telnet_fe *)p;
 
     while (!fe->is_quitting) {
@@ -1409,7 +1429,8 @@
 			    pj_activesock_get_user_data(asock);
 
-    PJ_UNUSED_ARG(op_key);
+    PJ_UNUSED_ARG(op_key);    
 
     if (sent <= 0) {
+	TRACE_((THIS_FILE, "Error On data send"));
         pj_cli_sess_end_session(&sess->base);
         return PJ_FALSE;
@@ -1442,5 +1463,5 @@
     cli_telnet_sess *sess = (cli_telnet_sess *)
                             pj_activesock_get_user_data(asock);
-    struct cli_telnet_fe *tfe = (struct cli_telnet_fe *)sess->base.fe;
+    cli_telnet_fe *tfe = (cli_telnet_fe *)sess->base.fe;
     unsigned char *cdata = (unsigned char*)data;    
     pj_status_t is_valid = PJ_TRUE;
@@ -1449,11 +1470,11 @@
     PJ_UNUSED_ARG(remainder);
 
-    if (status != PJ_SUCCESS && status != PJ_EPENDING) {
-        pj_cli_sess_end_session(&sess->base);
-        return PJ_FALSE;
-    }
-
     if (tfe->is_quitting)
         return PJ_FALSE;
+
+    if (status != PJ_SUCCESS && status != PJ_EPENDING) {
+	TRACE_((THIS_FILE, "Error on data read %d", status));
+        return PJ_FALSE;
+    }    
 
     pj_mutex_lock(sess->smutex);
@@ -1552,11 +1573,12 @@
 				     pj_sock_t newsock,
 				     const pj_sockaddr_t *src_addr,
-				     int src_addr_len)
-{
-    struct cli_telnet_fe *fe = (struct cli_telnet_fe *)
-                                pj_activesock_get_user_data(asock);
+				     int src_addr_len,
+				     pj_status_t status)
+{
+    cli_telnet_fe *fe = (cli_telnet_fe *) pj_activesock_get_user_data(asock);
+
     pj_status_t sstatus;
     pj_pool_t *pool;
-    cli_telnet_sess *sess;
+    cli_telnet_sess *sess = NULL;
     pj_activesock_cb asock_cb;
 
@@ -1566,4 +1588,12 @@
     if (fe->is_quitting)
         return PJ_FALSE;
+
+    if (status != PJ_SUCCESS && status != PJ_EPENDING) {
+	TRACE_((THIS_FILE, "Error on data accept %d", status));
+	if (status == PJ_ESOCKETSTOP) 
+	    telnet_restart(fe);	    
+	
+        return PJ_FALSE;
+    }    
 
     /* An incoming connection is accepted, create a new session */
@@ -1658,10 +1688,7 @@
 					 pj_cli_front_end **p_fe)
 {
-    struct cli_telnet_fe *fe;
+    cli_telnet_fe *fe;
     pj_pool_t *pool;
-    pj_sock_t sock = PJ_INVALID_SOCKET;
-    pj_activesock_cb asock_cb;
-    pj_sockaddr_in addr;
-    pj_status_t sstatus;
+    pj_status_t status;   
 
     PJ_ASSERT_RETURN(cli, PJ_EINVAL);
@@ -1670,5 +1697,5 @@
                           PJ_CLI_TELNET_POOL_SIZE, PJ_CLI_TELNET_POOL_INC,
                           NULL);
-    fe = PJ_POOL_ZALLOC_T(pool, struct cli_telnet_fe);
+    fe = PJ_POOL_ZALLOC_T(pool, cli_telnet_fe);
     if (!fe)
         return PJ_ENOMEM;
@@ -1688,40 +1715,84 @@
     fe->pool = pool;
 
-    if (!fe->cfg.ioqueue) {
+    if (!fe->cfg.ioqueue) {	
         /* Create own ioqueue if application doesn't supply one */
-        sstatus = pj_ioqueue_create(pool, 8, &fe->cfg.ioqueue);
-        if (sstatus != PJ_SUCCESS)
+        status = pj_ioqueue_create(pool, 8, &fe->cfg.ioqueue);
+        if (status != PJ_SUCCESS)
             goto on_exit;
         fe->own_ioqueue = PJ_TRUE;
     }
 
-    sstatus = pj_mutex_create_recursive(pool, "mutex_telnet_fe", &fe->mutex);
-    if (sstatus != PJ_SUCCESS)
+    status = pj_mutex_create_recursive(pool, "mutex_telnet_fe", &fe->mutex);
+    if (status != PJ_SUCCESS)
         goto on_exit;
 
     /* Start telnet daemon */
-    sstatus = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, 
-                             &sock);
-    if (sstatus != PJ_SUCCESS)
+    telnet_start(fe);
+
+    pj_cli_register_front_end(cli, &fe->base);
+
+    if (p_fe)
+        *p_fe = &fe->base;
+
+    return PJ_SUCCESS;
+
+on_exit:
+    if (fe->own_ioqueue)
+        pj_ioqueue_destroy(fe->cfg.ioqueue);
+
+    if (fe->mutex)
+        pj_mutex_destroy(fe->mutex);
+
+    pj_pool_release(pool);
+    return status;
+}
+
+static pj_status_t telnet_start(cli_telnet_fe *fe)
+{
+    pj_sock_t sock = PJ_INVALID_SOCKET;
+    pj_activesock_cb asock_cb;
+    pj_sockaddr_in addr;
+    pj_status_t status;   
+    int val;
+    int restart_retry;
+    unsigned msec;
+
+    /* Start telnet daemon */
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &sock);
+
+    if (status != PJ_SUCCESS)
         goto on_exit;
 
     pj_sockaddr_in_init(&addr, NULL, fe->cfg.port);
 
-    sstatus = pj_sock_bind(sock, &addr, sizeof(addr));
-    if (sstatus == PJ_SUCCESS) {
-	pj_sockaddr_in addr;
-	int addr_len = sizeof(addr);
-
-	sstatus = pj_sock_getsockname(sock, &addr, &addr_len);
-	if (sstatus != PJ_SUCCESS)
+    val = 1;
+    status = pj_sock_setsockopt(sock, SOL_SOCKET, SO_REUSEADDR,
+				&val, sizeof(val));
+
+    if (status != PJ_SUCCESS)
+	goto on_exit;
+
+    /* The loop is silly, but what else can we do? */
+    for (msec=MIN_WAIT_ON_TELNET_RESTART, restart_retry=0;
+	 restart_retry < MAX_RETRY_ON_TELNET_RESTART;
+	 ++restart_retry, msec=(msec<MAX_WAIT_ON_TELNET_RESTART?
+		          msec*2 : MAX_WAIT_ON_TELNET_RESTART))
+    {
+	status = pj_sock_bind(sock, &addr, sizeof(addr));
+	if (status != PJ_STATUS_FROM_OS(EADDRINUSE))
+	    break;
+	PJ_LOG(4,(THIS_FILE, "Address is still in use, retrying.."));
+	pj_thread_sleep(msec);
+    }    
+    
+    if (status == PJ_SUCCESS) {	
+	int addr_len = sizeof(addr);	
+
+	status = pj_sock_getsockname(sock, &addr, &addr_len);
+	if (status != PJ_SUCCESS)
 	    goto on_exit;
 	    
-        fe->cfg.port = pj_sockaddr_in_get_port(&addr);
-	if (param) 
-	    param->port = fe->cfg.port;
-	
-        PJ_LOG(3, (THIS_FILE, "CLI telnet daemon listening at port %d",
-		   fe->cfg.port));
-	
+        fe->cfg.port = pj_sockaddr_in_get_port(&addr);	
+
 	if (fe->cfg.prompt_str.slen == 0) {
 	    pj_str_t prompt_sign = {"> ", 2};
@@ -1738,33 +1809,49 @@
     }
 
-    sstatus = pj_sock_listen(sock, 4);
-    if (sstatus != PJ_SUCCESS)
+    status = pj_sock_listen(sock, 4);
+    if (status != PJ_SUCCESS)
         goto on_exit;
 
     pj_bzero(&asock_cb, sizeof(asock_cb));
-    asock_cb.on_accept_complete = &telnet_fe_on_accept;
-    sstatus = pj_activesock_create(pool, sock, pj_SOCK_STREAM(),
-                                   NULL, fe->cfg.ioqueue,
-		                   &asock_cb, fe, &fe->asock);
-    if (sstatus != PJ_SUCCESS)
+    asock_cb.on_accept_complete2 = &telnet_fe_on_accept;
+    status = pj_activesock_create(fe->pool, sock, pj_SOCK_STREAM(),
+                                  NULL, fe->cfg.ioqueue,
+		                  &asock_cb, fe, &fe->asock);
+    if (status != PJ_SUCCESS)
         goto on_exit;
 
-    sstatus = pj_activesock_start_accept(fe->asock, pool);
-    if (sstatus != PJ_SUCCESS)
+    status = pj_activesock_start_accept(fe->asock, fe->pool);
+    if (status != PJ_SUCCESS)
         goto on_exit;
 
     if (fe->own_ioqueue) {
         /* Create our own worker thread */
-        sstatus = pj_thread_create(pool, "worker_telnet_fe",
-                                   &poll_worker_thread, fe, 0, 0,
-                                   &fe->worker_thread);
-        if (sstatus != PJ_SUCCESS)
+        status = pj_thread_create(fe->pool, "worker_telnet_fe",
+                                  &poll_worker_thread, fe, 0, 0,
+                                  &fe->worker_thread);
+        if (status != PJ_SUCCESS)
             goto on_exit;
     }
 
-    pj_cli_register_front_end(cli, &fe->base);
-
-    if (p_fe)
-        *p_fe = &fe->base;
+    /** Fill telnet information and call pj_cli_telnet_on_started callback */
+    if (fe->cfg.on_started) {
+	char ip_addr[32];
+	pj_cli_telnet_info telnet_info;
+	pj_sockaddr hostip;
+
+	telnet_info.ip_address.ptr = ip_addr;
+	telnet_info.ip_address.slen = 0;
+	
+	status = pj_gethostip(pj_AF_INET(), &hostip);
+	if (status != PJ_SUCCESS)
+	    goto on_exit;
+
+	pj_strcpy2(&telnet_info.ip_address, 
+		   pj_inet_ntoa(hostip.ipv4.sin_addr));
+
+	telnet_info.port = fe->cfg.port;
+
+	(*fe->cfg.on_started)(&telnet_info);
+    }
 
     return PJ_SUCCESS;
@@ -1782,5 +1869,47 @@
         pj_mutex_destroy(fe->mutex);
 
-    pj_pool_release(pool);
-    return sstatus;
-}
+    pj_pool_release(fe->pool);
+    return status;
+}
+
+static pj_status_t telnet_restart(cli_telnet_fe *fe)
+{
+    pj_status_t status;
+    pj_cli_sess *sess;      
+
+    fe->is_quitting = PJ_TRUE;
+    if (fe->worker_thread) {	
+	pj_thread_join(fe->worker_thread);
+    }
+
+    pj_mutex_lock(fe->mutex);
+
+    /* Destroy all the sessions */
+    sess = fe->sess_head.next;
+    while (sess != &fe->sess_head) {
+	(*sess->op->destroy)(sess);
+	sess = fe->sess_head.next;
+    }
+
+    pj_mutex_unlock(fe->mutex);
+
+    /** Close existing activesock **/
+    status = pj_activesock_close(fe->asock);
+    if (status != PJ_SUCCESS)
+	goto on_exit;
+
+    if (fe->worker_thread) {
+	pj_thread_destroy(fe->worker_thread);
+	fe->worker_thread = NULL;
+    }
+
+    fe->is_quitting = PJ_FALSE;
+
+    /** Start Telnet **/
+    status = telnet_start(fe);
+    if (status == PJ_SUCCESS)
+	TRACE_((THIS_FILE, "Telnet Restarted"));
+    
+on_exit:
+    return status;
+}
Index: /pjproject/trunk/pjlib/include/pj/activesock.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/activesock.h	(revision 4460)
+++ /pjproject/trunk/pjlib/include/pj/activesock.h	(revision 4461)
@@ -133,5 +133,6 @@
     /**
      * This callback is called when new connection arrives as the result
-     * of pj_activesock_start_accept().
+     * of pj_activesock_start_accept(). If the status of accept operation is
+     * needed use on_accept_complete2 instead of this callback.
      *
      * @param asock	The active socket.
@@ -149,4 +150,28 @@
 				    const pj_sockaddr_t *src_addr,
 				    int src_addr_len);
+
+    /**
+     * This callback is called when new connection arrives as the result
+     * of pj_activesock_start_accept().
+     *
+     * @param asock	The active socket.
+     * @param newsock	The new incoming socket.
+     * @param src_addr	The source address of the connection.
+     * @param addr_len	Length of the source address.
+     * @param status	The status of the accept operation. This may contain
+     *			non-PJ_SUCCESS for example when the TCP listener is in
+     *			bad state for example on iOS platform after the
+     *			application waking up from background.
+     *
+     * @return		PJ_TRUE if further accept() is desired, and PJ_FALSE
+     *			when application no longer wants to accept incoming
+     *			connection. Application may destroy the active socket
+     *			in the callback and return PJ_FALSE here.
+     */
+    pj_bool_t (*on_accept_complete2)(pj_activesock_t *asock,
+				     pj_sock_t newsock,
+				     const pj_sockaddr_t *src_addr,
+				     int src_addr_len, 
+				     pj_status_t status);
 
     /**
Index: /pjproject/trunk/pjlib/include/pj/errno.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/errno.h	(revision 4460)
+++ /pjproject/trunk/pjlib/include/pj/errno.h	(revision 4461)
@@ -428,4 +428,9 @@
  */
 #define PJ_EGONE	    (PJ_ERRNO_START_STATUS + 23)/* 70023 */
+/**
+ * @hideinitializer
+ * Socket is stopped
+ */
+#define PJ_ESOCKETSTOP	    (PJ_ERRNO_START_STATUS + 24)/* 70024 */
 
 /** @} */   /* pj_errnum */
Index: /pjproject/trunk/pjlib/src/pj/activesock.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/activesock.c	(revision 4460)
+++ /pjproject/trunk/pjlib/src/pj/activesock.c	(revision 4461)
@@ -844,4 +844,14 @@
 			       " operation, stopping further ioqueue accepts.",
 			       asock->err_counter, asock->last_err));
+		
+		if ((status == PJ_STATUS_FROM_OS(OSERR_EWOULDBLOCK)) && 
+		    (asock->cb.on_accept_complete2)) 
+		{
+		    (*asock->cb.on_accept_complete2)(asock, 
+						     accept_op->new_sock,
+						     &accept_op->rem_addr,
+						     accept_op->rem_addr_len,
+						     PJ_ESOCKETSTOP);
+		}
 		return;
 	    }
@@ -851,11 +861,21 @@
 	}
 
-	if (status==PJ_SUCCESS && asock->cb.on_accept_complete) {
+	if (status==PJ_SUCCESS && (asock->cb.on_accept_complete2 || 
+				   asock->cb.on_accept_complete)) {
 	    pj_bool_t ret;
 
 	    /* Notify callback */
-	    ret = (*asock->cb.on_accept_complete)(asock, accept_op->new_sock,
-						  &accept_op->rem_addr,
-						  accept_op->rem_addr_len);
+	    if (asock->cb.on_accept_complete2) {
+		ret = (*asock->cb.on_accept_complete2)(asock, 
+						       accept_op->new_sock,
+						       &accept_op->rem_addr,
+						       accept_op->rem_addr_len,
+						       status);
+	    } else {
+		ret = (*asock->cb.on_accept_complete)(asock, 
+						      accept_op->new_sock,
+						      &accept_op->rem_addr,
+						      accept_op->rem_addr_len);	    
+	    }
 
 	    /* If callback returns false, we have been destroyed! */
Index: /pjproject/trunk/pjlib/src/pj/errno.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/errno.c	(revision 4460)
+++ /pjproject/trunk/pjlib/src/pj/errno.c	(revision 4461)
@@ -79,5 +79,6 @@
     PJ_BUILD_ERR(PJ_EIPV6NOTSUP,   "IPv6 is not supported"),
     PJ_BUILD_ERR(PJ_EAFNOTSUP,	   "Unsupported address family"),
-    PJ_BUILD_ERR(PJ_EGONE,	   "Object no longer exists")
+    PJ_BUILD_ERR(PJ_EGONE,	   "Object no longer exists"),
+    PJ_BUILD_ERR(PJ_ESOCKETSTOP,   "Socket is in bad state")
 };
 #endif	/* PJ_HAS_ERROR_STRING */
Index: /pjproject/trunk/pjsip-apps/build/Makefile
===================================================================
--- /pjproject/trunk/pjsip-apps/build/Makefile	(revision 4460)
+++ /pjproject/trunk/pjsip-apps/build/Makefile	(revision 4461)
@@ -34,5 +34,6 @@
 export PJSUA_SRCDIR = ../src/pjsua
 export PJSUA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
-			main.o pjsua_app.o pjsua_cmd.o pjsua_cli_cmd.o pjsua_ui_cmd.o
+            main.o pjsua_app.o pjsua_cli.o pjsua_cli_cmd.o pjsua_common.o \
+            pjsua_config.o pjsua_legacy.o
 export PJSUA_CFLAGS += $(_CFLAGS)
 export PJSUA_LDFLAGS += $(APP_LDFLAGS) $(APP_LDLIBS) $(LDFLAGS)
